New multi-line macros regexp (MACROS_RE) is too eager
Status: Closed Start date:

Priority: Normal Due date:

Assignee: Jean-Philippe Lang % Done: 0%
Category: Wiki Estimated time: 0.00 hour
Target version:

Resolution: Fixed Affected version:

Description

Using trunk (pre-2.1.0) version, Ruby 1.9.3 (Windows)

Tried latest macros feature: multi-line macros. | wrote macro, called {{lang}} to display different blocks of text depending of which
locale is active.

See the example, that produce a bug:

{{lang(ru)

Some russian text
I

{{lang(en)

Some english text

b}
According to MACROS_RE, it should extract exactly two macro appearances. However, it extracts only one macro with this body:

Some russian text
}}

{{lang(en)

Some english text

Attached a patch to fix this bug.
Note also another small change in the patch: "unless const_defined?(:MACRO_SUB_RE)*, instead of "unless
const_defined?(:MACROS_SUB_RE)" in application_helper.rb

Associated revisions

Revision 10276 - 2012-09-02 12:24 - Jean-Philippe Lang

Fixed: New multi-line macros regexp is too eager (#11736).

Revision 10277 - 2012-09-02 13:09 - Toshi MARUYAMA
fix typo "MACROS_SUB_RE" (#11736)

Contributed by Anton Argirov.

History

#1 - 2012-08-30 06:23 - Toshi MARUYAMA

- Target version set to 2.1.0

#2 - 2012-09-02 12:25 - Jean-Philippe Lang
- Status changed from New to Closed
- Assignee set to Jean-Philippe Lang

- Resolution set to Fixed

Fix committed in r10276 with test. Thanks for pointing this out.

#3 - 2012-09-02 12:49 - Toshi MARUYAMA
- Target version deleted (2.1.0)
https://www.redmine.org/projects/redmine/repository/svn/revisions/10276

Files

Fixed_multi-line_macros.patch 1.06 KB 2012-08-30 Anton Argirov
